* CUSQ-201604-ARRAY.sas : Les fondements et les usages de l'nonc ARRAY;
LIBNAME EDUC "C:\SASCOURS\";


* 1) DFINITION ET USAGE DES VECTEURS;
* 1.1) Avec boucle DO, pour faire un traitement identique  toutes les variables;
DATA MASTER;
  INPUT  XA XB XC  Y1-Y5  Q1A Q2A Q3B;
  FORMAT _NUMERIC_ 3.;
DATALINES;
  3   4 -99 -9  2 -9  4  0  8 -9 10
-99 -99 -99  6  3  2  4 -9 10 11 15
  4   2   8  3 -9 -9  5  3  8 12 -9
RUN;
DATA RECODE(DROP=I);
  SET MASTER;
  ARRAY MV (7) XA  XC  Y2-Y4  Q1A  Q3B;
  DO I=1 TO 7;
    IF MV(I) IN (-9,-99) THEN MV(I)=.;
  END;
RUN;
* Idem sans vecteur;
DATA RECODE2;
  SET MASTER;
  IF XA  = -99 THEN XA  = .;
  IF XC  = -99 THEN XC  = .;
  IF Y2  = -9  THEN Y2  = .;
  IF Y3  = -9  THEN Y3  = .;
  IF Y4  = -9  THEN Y4  = .;
  IF Q1A = -9  THEN Q1A = .;
  IF Q3B = -9  THEN Q3B = .;
RUN;
* 1.2) Usage des crochets et accolades au lieu des parenthses;
DATA RECODE(DROP=I);
  SET MASTER;
  ARRAY MV [7] XA  XC  Y2-Y4  Q1A  Q3B;
  DO I=1 TO DIM(MV);
    IF MV[I] IN (-9,-99) THEN MV[I]=.;
  END;
RUN;
DATA RECODE(DROP=I);
  SET MASTER;
  ARRAY MV {7} XA  XC  Y2-Y4  Q1A  Q3B;
  DO I=1 TO DIM(MV);
    IF MV{I} IN (-9,-99) THEN MV{I}=.;
  END;
RUN;


* 2) CONDITIONS D'EMPLOI DES VECTEURS;
* 2.1)) VECTEUR N'EXISTE QUE DANS L'TAPE DATA O IL A T CR;
DATA MASTER;
  INPUT  XA XB XC  Y1-Y5  Q1A Q2A Q3B;
  FORMAT _NUMERIC_ 3.;
DATALINES;
  3   4 -99 -9  2 -9  4  0  8 -9 10
-99 -99 -99  6  3  2  4 -9 10 11 15
  4   2   8  3 -9 -9  5  3  8 12 -9
RUN;
DATA RECODE(DROP=I);
  SET MASTER;
  ARRAY MV (7) XA  XC  Y2-Y4  Q1A  Q3B;
  DO I=1 TO 7;
    IF MV(I) IN (-9,-99) THEN MV(I)=.;
  END;(
RUN;
DATA TEST;
  SET RECODE;
  DO I=1 TO DIM(MV);
    IF MV(I) > 5 THEN MV(I)=5;
  END;
RUN;

* 2.2) Cration d'un vecteur de chanes de caractres, en contrlant
       la longueur des chanes;
DATA TEST;
  SET SASHELP.CLASS(KEEP=NAME  SEX  AGE);
  ARRAY SIDES (*) $11 SIDE_EFF1-SIDE_EFF6;
RUN;
PROC CONTENTS  DATA=WORK.TEST;
RUN;

* 2.3) Cration d'un vecteur de chanes de caractres sans mettre le
       symbole $ aprs la dimension (possible uniquement car aucune
       chane n'est cre par le programme;
DATA TEST;
  LENGTH SIDE_EFF1-SIDE_EFF4 $3;
  INFILE CARDS TRUNCOVER;
  INPUT PATIENT_ID SIDE_EFF1-SIDE_EFF4;
  ARRAY SIDES (*) SIDE_EFF1-SIDE_EFF4;
  NB=CMISS(OF SIDES(*));
DATALINES;
1056 ANG INC ARY XAB
2189 ARY ANG
3845 XAB WBO INC
RUN;

* 2.4) Cration d'un vecteur de chanes de caractres de longueur
       non-uniforme;
DATA TEST;
  SET EDUC.C_CLIENTS;
  ARRAY SIDES (*) _CHAR_;
  NB=CMISS(OF SIDES(*));
RUN;

* 2.5) Cration d'un vecteur  partir d'autres vecteurs - impossible,
       mais noter qu'une mme variable peut appartenir  plusieurs vecteurs;
DATA TEST;
  SET EDUC.EVALUATE(KEEP=STUDENT X: Y:);
  ARRAY VX (*) X1-X6;
  ARRAY VY (*) Y1-Y8;
* ARRAY VVXY (*) VX VY;        /* Engendre une erreur */
* ARRAY VVXY (*) VX(*) VY(*);  /* Engendre une erreur */
  ARRAY VVXY(*) X1-X6 Y1-Y8;
  DO I=1 TO DIM(VVXY);
    IF VVXY(I) > 3 THEN VVXY(I) = 3;
  END;   
RUN;


* 3) Vecteur sans boucle - pour simplifier l'appel des variables;
DATA ASSETS;
  INPUT ACC $  PR  AMOUNT;
  FORMAT ACC $4. _NUMERIC_ 5.  PR 2.;
DATALINES;
A003 5 43100     
A107 2 12600
A603 4 18700
B998 5 64500
C040 3 92800
C156 2 13400 
D450 1 25700
RUN;
DATA ASSETS_T(DROP=PR  AMOUNT);
  SET ASSETS;
  ARRAY VPROD (*) CELI CPG FERR REEE REER RVER;
  VPROD(PR) = AMOUNT;
  FORMAT _NUMERIC_ 5.;
RUN;
* Codage alternatif sans vecteur;
DATA ASSETS_T2(DROP=PR AMOUNT);
  SET ASSETS;
  IF PR=1 THEN CELI=AMOUNT;
  ELSE IF PR=2 THEN CPG=AMOUNT;
  ELSE IF PR=3 THEN FERR=AMOUNT;
  ELSE IF PR=4 THEN REEE=AMOUNT;
  ELSE IF PR=5 THEN REER=AMOUNT;
  ELSE IF PR=6 THEN RVER=AMOUNT;
RUN;


* 4) Forme simple de listes de variables;
DATA TEST;
  ARRAY VS (*) SAL_95-SAL_99  SAL_00-SAL_15;
  ARRAY VS (*) SAL_2016-SAL_2003;
  ARRAY PROD (*) CELI CPG FERR REEE REER RVER;
RUN;
PROC CONTENTS  DATA=TEST  POSITION;
RUN;


* 5) Usage des fonctions statistiques avec les vecteurs;
* 5.1) Usages de base;
DATA GRADES;
  INPUT STUDENT $4.  EX1  EX2  EX3  EX4  EX5  EX6;
  FORMAT EX1-EX6 2.;
DATALINES;
JEW4 70 80  . 50 90 60
BOM8 50 40 55 45 40 95
TRJ7  .  . 70 80  .  .
IVH5  .  .  .  .  .  . 
RHL0  . 75  .  .  .  .
RUN;
DATA STATF;
  SET GRADES;
  ARRAY VG (*) EX:;
  AVG=MEAN(OF VG(*));
  HIGH=MAX(OF VG(*));
  NBVALID=N(OF VG(*));
  NBMISS=NMISS(OF VG(*));
  FORMAT _NUMERIC_ 2.;
RUN;

* 5.2) Vrification que les fonctions statistiques avec variables caractres 
       (MIN, MAX et N notamment) ne sont pas acceptables, seule CMISS semble l'tre;
DATA GRADESC;
  INFORMAT STUDENT $4.  EX1-EX6 $1.;
  INFILE CARDS  DLM=","  DSD  TRUNCOVER;
  INPUT STUDENT  EX1  EX2  EX3  EX4  EX5  EX6;
DATALINES;
JEW4, B, C, A,,, D
BOM8, A, A, B, B, A, C
TRJ7, C, D, B, C,,,
RUN;
DATA TEST;
  SET GRADESC;
  ARRAY GC (6) EX1-EX6;
  MINIMUM=MIN(OF GC(*));
  MAXIMUM=MAX(OF GC(*));
  MANQ=CMISS(OF GC(*));
  VALIDES=N(OF GC(*));
RUN;

* 5.3) Combiner deux ou plusieurs vecteurs dans un mme appel; 
DATA TEST;
  SET EDUC.EVALUATE(KEEP=STUDENT SEX AGE X: Y:);
  ARRAY VX (*) X1-X6;
  ARRAY VY (*) Y1-Y8;  
  NBVALID=N(OF VX(*),OF VY(*));
  NBMANQ =NMISS(OF VX(*),OF VY(*));
RUN;


* 6) USAGES DE 'ARRAY' DANS DES NONCS SAS DIVERS;
* 6.1) Dans nonc PUT;
DATA GRADES;
  INPUT STUDENT $4.  EX1  EX2  EX3  EX4  EX5  EX6;
  FORMAT EX1-EX6 2.;
DATALINES;
JEW4 70 80  . 50 90 60
BOM8 50 40 55 45 40 95
TRJ7  .  . 70 80  .  .
IVH5  .  .  .  .  .  . 
RHL0  . 75  .  .  .  .
RUN;
* 6.1A) Pour crer un fichier dlimit;
DATA _NULL_;
  SET GRADES;
  ARRAY VG (*) EX1-EX6;
  FILE "C:\EXERCICES\TOTO.csv"  DLM=","  DSD;
  PUT STUDENT VG(*);
RUN;
* 6.1B) Sans format, pas trop esthtique;
DATA _NULL_;
  SET GRADES;
  ARRAY VG (*) EX1-EX6;
  PUT VG(*);
RUN;
* 6.1C) Avec format, beaucoup plus lisible;
DATA _NULL_;
  SET GRADES;
  ARRAY VG (*) EX1-EX6;
  PUT STUDENT $4. (VG(*)) (5.);
RUN;
* 6.1D) Format plus sophistiqu;
DATA _NULL_;
  SET GRADES;
  ARRAY VG (*) EX1-EX6;
  PUT STUDENT $4. (VG(*)) (3*5. +4 3*5.);
RUN;

* 6.2) Dans nonc INPUT;
* 6.2A) Codage de base, sans vecteur;
DATA ASSETS(DROP=PRODUCT AMOUNT);
  INPUT ACCOUNT $  PRODUCT  AMOUNT;
  IF PRODUCT=1 THEN CELI=AMOUNT;
  ELSE IF PRODUCT=2 THEN CPG=AMOUNT;
  ELSE IF PRODUCT=3 THEN FERR=AMOUNT;
  ELSE IF PRODUCT=4 THEN REEE=AMOUNT;
  ELSE IF PRODUCT=5 THEN REER=AMOUNT;
  ELSE IF PRODUCT=6 THEN RVER=AMOUNT;
  FORMAT CELI CPG FERR REEE REER RVER NLMNY10.;
DATALINES;
A003 5 43100
A107 2 12600
A603 4 18700
B998 5 64500
C040 3 92800
C156 2 13400 
D450 1 25700
RUN;
* 6.2B) Code amlior avec vecteur;
DATA ASSETS2(DROP=PRODUCT AMOUNT);
  INPUT ACCOUNT $  PRODUCT  AMOUNT; 
  ARRAY VPROD (*) CELI CPG FERR REEE REER RVER;
  VPROD(PRODUCT)=AMOUNT;
  FORMAT CELI CPG FERR REEE REER RVER NLMNY10.; 
DATALINES;
A003 5 43100     
A107 2 12600
A603 4 18700
B998 5 64500
C040 3 92800
C156 2 13400 
D450 1 25700
RUN;
* 6.2C) Code optimis avec usage du vecteur dans INPUT;
DATA ASSETS3(DROP=PRODUCT);
  FORMAT ACCOUNT $4.  CELI CPG FERR REEE REER RVER NLMNY10.; 
  ARRAY VPROD (*) CELI CPG FERR REEE REER RVER;
  INPUT ACCOUNT $  PRODUCT  VPROD(PRODUCT); 
DATALINES;
A003 5 43100     
A107 2 12600
A603 4 18700
B998 5 64500
C040 3 92800
C156 2 13400 
D450 1 25700
RUN;
* 6.2D) Mme optimisation, si le code de produit est une chane de caractres...
        (pas ajout dans prsentation au CUSQ);
PROC FORMAT;
  INVALUE FPROD   "CELI" = 1
                  "CPG " = 2
                  "FERR" = 3
                  "REEE" = 4
                  "REER" = 5
                  "RVER" = 6;
RUN;
DATA ASSETS4(DROP=PRODUCT);
  FORMAT ACCOUNT $4.  CELI CPG FERR REEE REER RVER NLMNY10.; 
  ARRAY VPROD (*) CELI CPG FERR REEE REER RVER;
  INPUT ACCOUNT $4. +1  PRODUCT FPROD4.  VPROD(PRODUCT); 
DATALINES;
A003 REER 43100
A107 CPG  12600
A603 REEE 18700
B998 REER 64500
C040 FERR 92800
C156 CPG  13400
D450 CELI 25700
RUN;
PROC COMPARE  BASE=ASSETS2  COMP=ASSETS4;
RUN;

* 6.3)  Filtrage et traitement conditionnel avec IF et WHERE;
* 6.3A) Fonction statistique en filtrage;
DATA SELECT;
  SET GRADES;
  ARRAY VG (*) EX1-EX6;
  IF MEAN(OF VG(*)) > 50 AND
     N(OF VG(*)) >= 3;
* WHERE MEAN(OF VG(*)) > 50;  /* Gnre une erreur */
RUN;
* 6.3B) Fonction statistique en traitement conditionnel;
DATA SELECT;
  SET GRADES;
  ARRAY VG (*) EX1-EX6;
  IF MEAN(OF VG(*)) > 50 AND
     N(OF VG(*)) >= 3 THEN FLAG=1;
RUN;
* 6.3C) Vrification d'une valeur numrique ou caractre parmi une srie de variables;
DATA GRADESC;
  INFORMAT STUDENT $4.  EX1-EX6 $4.;
  INFILE CARDS  DLM=","  DSD  TRUNCOVER;
  INPUT STUDENT  EX1  EX2  EX3  EX4  EX5  EX6;
DATALINES;
JEW4, B, C, A,,, D
BOM8, A, A, B, B, A, C
TRJ7, C, D, B, C,,,
RUN;
DATA SELECT;
  SET GRADESC;
  IF EX1="A" OR EX2="A" OR EX3="A" OR
     EX4="A" OR EX5="A" OR EX6="A";
RUN;
DATA SELECT2;
  SET GRADESC;
  ARRAY GC (*) $ EX1-EX6;
  IF "A" IN GC;
  /* ne PAS utiliser IF "A" IN GC(*); */
RUN;

* 6.4) Dans RETAIN;
PROC SORT  DATA=EDUC.RESULTS  OUT=RESULTS;
  BY AGE;
RUN;

DATA AGG1;
  SET RESULTS;
  BY AGE;
  ARRAY VTESTS (3) TEST1-TEST3;
  ARRAY VCUM (3) CUM1-CUM3;
* RETAIN VCUM(*);  /* Cette forme ne fonctionne pas !!! */
  RETAIN VCUM;  
  DO I=1 TO DIM(VTESTS);
    VCUM(I)=SUM(VCUM(I),VTESTS(I));
  END;
  IF LAST.AGE THEN DO;
     OUTPUT;
     CALL MISSING (OF VCUM(*));
  END;
RUN;

* 6.5)  Autres noncs (test de ce qui est PERMIS et PAS PERMIS);
* 6.5A) Dans KEEP;
data test;
  set sashelp.class;
  array vv (*) height weight age;
* keep vv(*);
  keep vv;  /* KEEP et DROP ne permettent pas l'emploi d'un vecteur */
run;

* 6.5B) Dans RENAME;
data test;
  set sashelp.class;
  array vv (*) height weight age;
  array ww (*) r1 r2 r3;
  rename vv=ww;  /* RENAME ne permet pas l'emploi d'un vecteur */
  rename vv(*)=ww(*);  /* RENAME ne permet pas l'emploi d'un vecteur */
run;

* 6.5C) Dans LENGTH;
data test;
  set sashelp.class;
  array vv (*) height weight age;
* length vv(*) 6;  /* LENGTH ne permet pas l'emploi d'un vecteur */
  length vv 6;  /* LENGTH ne permet pas l'emploi d'un vecteur */
run;

* 6.5D) Dans FORMAT;
data test;
  set sashelp.class;
  array vv (*) height weight age;
  format vv(*) Z8.;  /* FORMAT ne permet pas l'emploi d'un vecteur */
  format vv Z8.;  /* FORMAT ne permet pas l'emploi d'un vecteur */
run;

* 6.5E) Dans ATTRIB;
data test;
  set sashelp.class;
  array vv (*) height weight age;
* ATTRIB VV(*) FORMAT=6.1;  /* ATTRIB ne permet pas l'emploi d'un vecteur */
* ATTRIB VV FORMAT=6.1;  /* ATTRIB ne permet pas l'emploi d'un vecteur */
run;


* 7) Tableaux  deux dimensions;
* 7.1) Solution traditionnelle sans vecteurs;
DATA CALC(DROP=I);
  SET EDUC.EVALUATE(KEEP=STUDENT SEX AGE X: Y:);
  Z1 = X1 * Y1;
  Z2 = X2 * Y2;
  Z3 = X3 * Y3;
  Z4 = X4 * Y4;
  Z5 = X5 * Y5;
  Z6 = X6 * Y6;
RUN;

* 7.2) Solution traditionnelle avec trois vecteurs;
DATA CALC2(DROP=I);
  SET EDUC.EVALUATE(KEEP=STUDENT SEX AGE X: Y:);
  ARRAY X (*) X1-X6;
  ARRAY Y (*) Y1-Y6;
  ARRAY Z (*) Z1-Z6;
  DO I=1 TO DIM(X);
    Z(I) = X(I) * Y(I);
  END;
RUN;

* 7.3) Solution avec un tableau;
DATA CALC3(DROP=I);
  SET EDUC.EVALUATE(KEEP=STUDENT SEX AGE X: Y:);
  ARRAY MAT (3,6) X1-X6  Y1-Y6  Z1-Z6;
  DO I=1 TO DIM2(MAT);
    MAT(3,I) = MAT(1,I) * MAT(2,I);
  END;
RUN;
PROC COMPARE  BASE=CALC  COMP=CALC3;
  ID STUDENT;
RUN;

* 7.4) Fonction statistique sur un tableau;
DATA CALC4;
  SET EDUC.EVALUATE(KEEP=STUDENT SEX AGE X: Y:);
  ARRAY MAT (2,6) X1-X6  Y1-Y6;
  MAT_SUM=SUM(OF MAT(*));
  MAS_NB =N(OF MAT(*));
  NB_R1=N(OF MAT(1,*)); /* Impossible d'appliquer une fonction statistique  une range/colonne du tableau */
RUN;


* 8) Vecteurs borns ailleurs que 1  N;
DATA ASSETS;
  INPUT ACC $  YEAR  AMOUNT;
  FORMAT ACC $4. _NUMERIC_ 6.;
DATALINES;
A003 2015 43100     
A107 2012 12600
A107 2014 18700
B998 2015 64500
C156 2013 92800
C156 2012 13400 
D450 2014 25700
D450 2014 23800 
E224 2015 31460
E677 2013 25400
E677 2012 29650
E677 2013 28600
RUN;
* Codage alternatif sans vecteur;
DATA ASSETS_T(DROP=AMOUNT YEAR);
  SET ASSETS;
  IF YEAR=2012 THEN SAL_2012=AMOUNT;
  ELSE IF YEAR=2013 THEN SAL_2013=AMOUNT;
  ELSE IF YEAR=2014 THEN SAL_2014=AMOUNT;
  ELSE IF YEAR=2015 THEN SAL_2015=AMOUNT;
  ELSE IF YEAR=2016 THEN SAL_2016=AMOUNT;
  FORMAT _NUMERIC_ 9.;
RUN;
DATA ASSETS_T2(DROP=POS  AMOUNT  YEAR);
  SET ASSETS;
  ARRAY VSAL (*) SAL_2012-SAL_2016;
  POS=YEAR-2011;
  VSAL(POS) = AMOUNT;
  FORMAT _NUMERIC_ 9.;
RUN;
DATA ASSETS_T3(DROP=AMOUNT  YEAR);
  SET ASSETS;
  ARRAY VSAL (2012:2016) SAL_2012-SAL_2016;
  VSAL(YEAR) = AMOUNT;
  FORMAT _NUMERIC_ 9.;
RUN;



